﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.ComponentModel;  // neu

namespace TabControl_ListView {
    public class FileItem : IComparable<FileItem> {

        public enum StudentTyp { Nachname, Vorname, Mnr};

        public static StudentTyp sortType = StudentTyp.Nachname;
        public static ListSortDirection direction = ListSortDirection.Ascending;

        private String nachname = "";
        private String vorname = "";
        private uint mnr = 0;


        public FileItem() {
        }


        public String Nachname {
            get { return nachname; }
            set { nachname = value; }
        }
        public String Vorname {
            get { return vorname; }
            set { vorname = value; }
        }
        public uint Mnr {
            get {
                return mnr;
            }
            set { mnr = value; }
        }

        public int CompareTo(FileItem other) {
            int retcode = 0;
            switch (sortType) {
                case StudentTyp.Nachname: retcode = nachname.CompareTo(other.nachname); break;
                case StudentTyp.Vorname: retcode = vorname.CompareTo(other.vorname); break;
                case StudentTyp.Mnr: retcode = mnr.CompareTo(other.mnr); break;                
            }
            // if the sort is ascending, multiplication with -1
            if (direction != ListSortDirection.Ascending) {
                retcode = -retcode;
            }
            return retcode;
        }

    }
}
