﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Windows.Controls;
using System.ComponentModel;
using System.Windows;
using System.Windows.Input;
using System.Diagnostics;
using System.Windows.Data;  // new

namespace TabControl_ListView {
    class MyListView : ListView {

        MyTabItem tabitem;

        private List<FileItem> _studentliste = new List<FileItem>();

        public MyListView(MyTabItem tabitem, String path) {
            this.tabitem = tabitem;
            if (path.Length == 0)
                tabitem.Title = "-";
            else {
                tabitem.Title = path;               
            }
            setGUI();
            loadData();
        }

        private void setGUI() {
            this.AddHandler(GridViewColumnHeader.ClickEvent, new RoutedEventHandler(ColumnHeader_Click));

            this.SelectionChanged += new SelectionChangedEventHandler(fileTable_SelectionChanged);
            this.MouseDoubleClick += new MouseButtonEventHandler(fileTable_MouseDoubleClick);

            GridView gridView = new GridView();
            GridViewColumn col;
           
            col = new GridViewColumn();
            col.Header = "Nachname";
            col.DisplayMemberBinding = new Binding("Nachname");
            col.Width = 170;
            gridView.Columns.Add(col);

            col = new GridViewColumn();
            col.Header = "Vorname";
            col.DisplayMemberBinding = new Binding("Vorname");
            col.Width = 100;
            gridView.Columns.Add(col);

            col = new GridViewColumn();
            col.Header = "Matrikelnummer";
            col.DisplayMemberBinding = new Binding("Mnr");
            col.Width = 120;
            gridView.Columns.Add(col);

            this.View = gridView;
        }  // setGUI



        private void fileTable_SelectionChanged(object sender, SelectionChangedEventArgs e) {
            FileItem fitem = (FileItem)SelectedItem;
            if (fitem != null) {
                // ?????
            }
        }  // fileTable_SelectionChanged

        public void fileTable_MouseDoubleClick() {
            FileItem fitem = (FileItem)SelectedItem;
            if (fitem != null) {
                // ?????
            }
        } // fileTable_MouseDoubleClick

        private void fileTable_MouseDoubleClick(object sender, MouseButtonEventArgs e) {
            fileTable_MouseDoubleClick();
        } // fileTable_MouseDoubleClick


        GridViewColumnHeader _lastHeaderClicked = null; // wich column was the last click
        ListSortDirection _lastDirection = ListSortDirection.Ascending;

        private void ColumnHeader_Click(object sender, RoutedEventArgs e) {
            ListSortDirection direction;

            GridViewColumnHeader headerClicked = e.OriginalSource as GridViewColumnHeader;  // Holen der Column
            // if the last click was the actual, then the sort a reverse
            if (headerClicked != null) {
                if (headerClicked != _lastHeaderClicked) {
                    direction = ListSortDirection.Ascending;
                }
                else {
                    if (_lastDirection == ListSortDirection.Ascending) {
                        direction = ListSortDirection.Descending;
                    }
                    else {
                        direction = ListSortDirection.Ascending;
                    }
                }
                FileItem.direction = direction;
                _lastHeaderClicked = headerClicked;
                _lastDirection = direction;

                if (headerClicked.Column.DisplayMemberBinding == null) return;  // Icon column
                // sortBy by Nachname, Vorname, Mnr
                string sortBy = (headerClicked.Column.DisplayMemberBinding as Binding).Path.Path;
                switch (sortBy) {
                    case "Nachname": FileItem.sortType = FileItem.StudentTyp.Nachname; break;
                    case "Vorname": FileItem.sortType = FileItem.StudentTyp.Vorname; break;
                    case "Mnr": FileItem.sortType = FileItem.StudentTyp.Mnr; break;                    
                    default: return; 
                }
                _studentliste.Sort();  // sort in an external Array
                BeginInit();
                Items.Clear();  // insert in the ListView
                foreach (FileItem fitem in _studentliste) {
                    Items.Add(fitem);
                }
                EndInit();
            }
        }  // ColumnHeader_Click

        private void loadData() {
            _studentliste.Clear();
            for (int i=1; i<=100; i++) {
              FileItem fitem = new FileItem();
              fitem.Nachname = "Meier_" + i;
              fitem.Vorname = "Andrea_"+i;
              fitem.Mnr = (uint) i;
               _studentliste.Add(fitem);
              Items.Add(fitem);
            }
        }
    }
}
