﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


// neu
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Windows.Media;

namespace TabControl_ListView {
    class MyTabItem :  TabItem {
        
        CloseableHeader closableTabHeader;
        private IDeleteTabExecuted parent;

        public MyTabItem(IDeleteTabExecuted parent) {
            this.parent = parent;

            // Create an instance of the usercontrol
            closableTabHeader = new CloseableHeader();
            // Assign the usercontrol to the tab header
            this.Header = closableTabHeader;
            closableTabHeader.button_close.MouseEnter += new MouseEventHandler(button_close_MouseEnter);
            closableTabHeader.button_close.MouseLeave += new MouseEventHandler(button_close_MouseLeave);
            closableTabHeader.button_close.Click += new RoutedEventHandler(button_close_Click);
        }

        public string Title {
            set {
                ((CloseableHeader)this.Header).label_TabTitle.Content = value;
            }
        }

        protected override void OnSelected(System.Windows.RoutedEventArgs e) {
            base.OnSelected(e);
            ((CloseableHeader)this.Header).button_close.Visibility = Visibility.Visible;
        }


        protected override void OnUnselected(System.Windows.RoutedEventArgs e) {
            base.OnUnselected(e);
            ((CloseableHeader)this.Header).button_close.Visibility = Visibility.Hidden;
        }

        protected override void OnMouseEnter(MouseEventArgs e) {
            base.OnMouseEnter(e);
            ((CloseableHeader)this.Header).button_close.Visibility = Visibility.Visible;
        }

        protected override void OnMouseLeave(MouseEventArgs e) {
            base.OnMouseLeave(e);
            if (!this.IsSelected) {
                ((CloseableHeader)this.Header).button_close.Visibility = Visibility.Hidden;
            }
        }


        // Button MouseEnter - When the mouse is over the button - change color to Red
        void button_close_MouseEnter(object sender, MouseEventArgs e) {
            ((CloseableHeader)this.Header).button_close.Foreground = Brushes.Red;
        }

        // Button MouseLeave - When mouse is no longer over button - change color back to black
        void button_close_MouseLeave(object sender, MouseEventArgs e) {
            ((CloseableHeader)this.Header).button_close.Foreground = Brushes.Black;
        }

        // Button Close Click - Remove the Tab - (or raise
        // an event indicating a "CloseTab" event has occurred)
        void button_close_Click(object sender, System.Windows.RoutedEventArgs e) {
            //((TabControl)this.Parent).Items.Remove(this);
            parent.DeleteTabExecuted();
        }

        // Label SizeChanged - When the Size of the Label changes
        // (due to setting the Title) set position of button properly
        void label_TabTitle_SizeChanged(object sender, System.Windows.SizeChangedEventArgs e) {
            ((CloseableHeader)this.Header).button_close.Margin = new System.Windows.Thickness(
               ((CloseableHeader)this.Header).label_TabTitle.ActualWidth + 5, 3, 4, 0);
        }

    }
}
